//      
procedure CONV_IMPORT;

const xlXMLSpreadsheet = $0000002E;

var   OpenDlg: TOpenDialog;
      ExcelApplication, ExcelWorkbook, UsedRange;
      sFileName, sFileExt, sFileXML, sFilter: string;
      i: integer;

begin

  {   XLS   }
  OpenDlg := TOpenDialog.Create(Application);
  OpenDlg.Options := 524356;

  //     
  StoredProc.StoredProcName := 'UDO_P_CONV_LINKS_FILTER';
  StoredProc.Prepare;
  StoredProc.ParamByName('psUNITCODE').Value := UNITCODE;
  StoredProc.ExecProc;
  sFilter := StoredProc.ParamByName('psFILTER').Value;
  if sFilter = '' then
  begin
    ShowMessage('     .');
    exit;
  end;

  OpenDlg.Filter := sFilter;
  OpenDlg.Title:='   ';

  {      XLS }
  if OpenDlg.Execute then begin
    //   
    sFileName := OpenDlg.Files.Strings[0];
    i := pos('\', sFileName);
    while i > 0 do begin
      sFileName := Copy(sFileName, i+1, Length(sFileName)-i);
      i := pos('\', sFileName);
    end;
    sFileExt := AnsiUpperCase(ExtractFileExt(sFileName));

    //  ,     
    StoredProc.StoredProcName := 'UDO_P_CONCEPTDOCS_LOAD_FILE';
    StoredProc.Prepare;
    if GetDocument(0) = '' then
      StoredProc.ParamByName('pnRN').Value := 0
    else
      StoredProc.ParamByName('pnRN').Value := GetDocument(0);
    StoredProc.ParamByName('pnCOMPANY').Value := COMPANY;
    StoredProc.ParamByName('psUNITCODE').Value := UNITCODE;
    StoredProc.ParamByName('psFILE_NAME').Value := 'q'+sFileName;
    if (sFileExt = '.XLS') or (sFileExt = '.XLSX') then
     begin
      {   Excel.Application }
      ExcelApplication := CreateOleObject('Excel.Application');
      if VarIsEmpty(ExcelApplication) then
        ShowMessage('Excel  !    .')
      else
      try
        ExcelApplication.DisplayAlerts := False;
        ExcelApplication.Visible := False; //True;
        ExcelWorkbook := ExcelApplication.Workbooks.Open(OpenDlg.Files.Strings[0]);
        sFileXML := ChangeFileExt(OpenDlg.Files.Strings[0], '.xml');
        ExcelWorkbook.SaveAs(sFileXML, xlXMLSpreadsheet, '', '', False, False);
        ExcelWorkbook.Close;
      finally
        ExcelApplication.DisplayAlerts := True;
        ExcelApplication.Quit;
        ExcelApplication := Unassigned;
        if sFileXML <> '' then begin
          StoredProc.ParamByName('cFILE').LoadFromFile(sFileXML,ftOraClob);
          DeleteFile(sFileXML);
        end;
      end;
     end
    else
     StoredProc.ParamByName('cFILE').LoadFromFile(OpenDlg.Files.Strings[0],ftOraClob);

    //  
    StoredProc.ExecProc;

  end;
  FreeAndNil(OpenDlg);
end;

